#ifndef __OBJECT_H__
#define __OBJECT_H__

#include <cstdio>

#define _DESTRUCTOR_IN_HEADER

class Object
{
public:
	Object();
#ifdef _DESTRUCTOR_IN_HEADER
	~Object()
	{
	}
#else
	~Object();
#endif

private:
	class Counter
	{
	public:
		Counter()
			: _count(0)
		{
			printf("Counter: %p %d\n", this, _count);
		}

		~Counter()
		{
			printf("~Counter: %p %d\n", this, _count);
		}

		void operator++()	{ ++_count; }
		void operator--()	{ --_count; }

	private:
		int _count;
	};

	class Foo
	{
	public:
		Foo() { ++counter(); }
		~Foo() { --counter(); }

	private:
		Counter& counter()
		{
			static Counter s_counter;
			return s_counter;
		}
	} foo;
};

#endif // __OBJECT_H__
